=== booster/CMakeLists.txt ===
add_library(booster
bitset_index.c       hashmap.c            io.c                 sort.c               tree_utils.h
bitset_index.h       hashmap.h            io.h                 sort.h               tree.c               
booster.c            hashtables_bfields.c prng.c               stats.c              tree.h
externs.h            hashtables_bfields.h prng.h               stats.h              tree_utils.c
booster.h
)
