=== lbfgsb/CMakeLists.txt ===
add_library(lbfgsb
lbfgsb_new.cpp
)
