=== phylo-yaml/CMakeLists.txt ===
add_library(phyloYAML
statespace.h
statespace.cpp
)

target_link_libraries(phyloYAML yaml-cpp)
