=== debian/changelog ===
iqtree (2.0.7+dfsg-2) unstable; urgency=medium

  * Team upload.
  * cmake-4.patch: new: bump required cmake to 3.10. (Closes: #1113054)
  * gcc-15.patch: new: fix build failure with gcc-15. (Closes: #1096850)

 -- Étienne Mollier <emollier@debian.org>  Wed, 08 Oct 2025 20:52:17 +0200

iqtree (2.0.7+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Build-Depends: libboost-dev
  * Executables are now named iqtree2
  * Drop invalid option `-omp` from build time test
  
  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0

 -- Andreas Tille <tille@debian.org>  Fri, 21 Jan 2022 12:05:21 +0100
