=== debian/control ===
Source: iqtree
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Kevin Murray <kdmfoss@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libboost-dev,
               libeigen3-dev,
               libsprng2-dev,
               mpi-default-dev,
               zlib1g-dev,
               help2man,
               time,
               chrpath
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/iqtree
Vcs-Git: https://salsa.debian.org/med-team/iqtree.git
Homepage: http://www.cibiv.at/software/iqtree/
Rules-Requires-Root: no

Package: iqtree
Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: efficient phylogenetic software by maximum likelihood
 IQ-TREE is a very efficient maximum likelihood phylogenetic software
 with following key features among others:
 .
  * A novel fast and effective stochastic algorithm to estimate maximum
    likelihood trees. IQ-TREE outperforms both RAxML and PhyML in terms
    of likelihood while requiring similar amount of computing time (see
    Nguyen et al., 2015)
  * An ultrafast bootstrap approximation to assess branch supports (see
    Minh et al., 2013).
  * A wide range of substitution models for binary, DNA, protein, codon,
    and morphological alignments.
  * Ultrafast model selection for all data types, 10 to 100 times faster
    than jModelTest and ProtTest.
  * Finding best partition scheme like PartitionFinder.
  * Partitioned models with mixed data types for phylogenomic (multi-
    gene) alignments, allowing for separate, proportional, or joint
    branch lengths among genes.
  * Supporting the phylogenetic likelihod library (PLL) (see Flouri et
    al., 2014)
